/******************************************************************************/
/*                                                                            */
/*                    CAO & VLSI's cad tools chain Alliance                   */
/*                                                                            */
/*     Product  : Standard Cell Placer                                        */
/*     File     :                                                             */
/*     Contents :                                                             */
/*                                                                            */
/*     (c) Copyright 1992 Laboratoire MASI equipe CAO & VLSI                  */
/*     All rights reserved                                                    */
/*     Hot line  : cao-vlsi@masi.ibp.fr (e-mail)                              */
/*                                                                            */
/*     Author(s)   : Pierre Fedrichkine                 Date : ../../....     */
/*     Modified by :                                    Date : ../../....     */
/*     Modified by :                                    Date : ../../....     */
/*     Modified by :                                    Date : ../../....     */
/*                                                                            */
/******************************************************************************/
#include "scp_types.h"

/******* fonction de destruction des structures de donnees chainees  **********/

void efface_structure()
{
    int ind_cell;
    int ind_net;
    struct connect_list_struct *pt_cn1; 
    struct connect_list_struct *pt_cn2; 
    struct cell_list_struct *pt_cl1; 
    struct cell_list_struct *pt_cl2; 

    /************ parcours et effacement des listes chainees  *****************/

    /************ parcours des listes de connecteurs des cellules *************/

    for (ind_cell = 0;ind_cell < NBCELL;ind_cell++)
        if (pt_cn1=CELL[ind_cell].first)
	    for(pt_cn2=pt_cn1->next;pt_cn2;pt_cn1=pt_cn2,pt_cn2=pt_cn2->next)
		free(pt_cn1);

    /**************** parcours des listes de cellules des nets ****************/

    for (ind_net = 0;ind_net < NBNET;ind_net++)
	if (pt_cl1=NET[ind_net].first)
	    for(pt_cl2=pt_cl1->next;pt_cl2;pt_cl1=pt_cl2,pt_cl2=pt_cl2->next)
		free(pt_cl1);
}
